<template>
    <div>
        <div class="row">
            <div class="col-8">
                <h4> Nro : {{ props.cabecera.id_baprocab }} - Tipo : {{ props.cabecera.d_tipo_proceso }} - Archivo: {{
                    props.cabecera.archivo }} </h4>
            </div>
            <div class="col mb-3 text-end">
                <a class="btn btn-principal mx-2 text-uppercase fs-6 px-2" :href="urlApi + 'downloadFile?file_name=' + props.cabecera.archivo"
                    target="_blank" v-if="props.cabecera.tipo_proceso == 'G'"  title="Descargar Archivo" alt="Descargar Archivo">
                    <i class="bi bi-file-earmark-arrow-down me-1"></i>
                    Descargar Archivo
                </a><!-- SE MUESTRA SOLO CUANDO TIPO ES = G -->
                <a :href="respaldoImprimir()//pasar uno por uno como necesite el jasper
                    " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal px-2 ">
                    <i class="bi bi-printer"></i>
                </a>
            </div>
        </div>
        <table class="table  table-striped" v-if="data.listadoDetallePedido.length > 0">
            <thead>
                <tr>
                    <th scope="col">APELLIDO Y NOMBRE</th>
                    <!-- <th scope="col">DNI</th> -->
                    <th scope="col">CUIL</th>
                    <th scope="col">BAPRO</th>
                    <th scope="col">CBU</th>

                </tr>
            </thead>
            <tbody>
                <tr v-for="detalle in data.listadoDetallePedido" :key="detalle.id_baprodeta">
                    <td v-text="detalle.apyn"></td>
                    <!-- <td v-text="detalle.apellido + detalle.nombres"></td> -->
                    <!-- <td v-text="detalle.doc"></td> -->
                    <td v-text="detalle.cuil"></td>
                    <!-- <td v-text="detalle.baprosuc + '-' + detalle.d_baprosuc"></td> -->
                    <td v-text="detalle.sucursal"></td>
                    <td v-text="detalle.cbu"></td>
                </tr>
            </tbody>
            <td> 
                <h6 class="text-black fs-4 text-uppercase" scope="col" style="padding: 15px 10px !important">
                    TOTAL:
                    <span class="pt-3 pb-3 px-2 text-black text-uppercase text-left" v-text="data.listadoDetallePedido.length"></span>
                </h6>
            </td>
        </table>
        <div v-else class="alert alert-secondary" role="alert">
            No hay elementos para mostrar
        </div>
    </div>
</template>
  
<script setup lang="ts">

import { onMounted, reactive } from "vue";
import http from "@/http";
import type { AxiosResponse } from "axios";
import { loading, urlApi, getUrl } from "@/shared.js";

//entitie
import Pedido from "@/entities/Bapro/PedidosCuenta/Pedidocabecera";
import Pedidodetalle from "@/entities/Bapro/PedidosCuenta/Pedidodetalle";

var data = reactive({
    listadoDetallePedido: [] as Pedidodetalle[],
});

const props = defineProps({
    cabecera: { type: Pedido, required: true }
});

onMounted(async () => {

    loading.show();
    const paramsRequest: any = {};
    paramsRequest.id_baprocab = props.cabecera.id_baprocab;

    const response: AxiosResponse<Pedidodetalle[]> = await http.request<Pedidodetalle[]>({
        method: "GET",
        url: urlApi + "getDetallePedidoBapro",
        params: paramsRequest,
        transformResponse: [
            (data: string) => {
                const detalleCuentas: Pedidodetalle[] = JSON.parse(data);
                const dataAux: Pedidodetalle[] = [];
                detalleCuentas.forEach((element: Pedidodetalle) => {
                    dataAux.push(Object.assign(new Pedidodetalle(), element));
                });
                return dataAux;
            },
        ],
    });
    loading.hide();
    data.listadoDetallePedido = response.data;

})

function respaldoImprimir() {
    var queryParams: any = {
        id_baprocab: props.cabecera.id_baprocab,
    }
    return getUrl('respaldoImprimir', [], queryParams);

}

</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
  